from Products.ZPatterns.Providers import Provider
from Products.ZPatterns.Proxy import ProxyManager
from Products.ZPatterns.PlugIns import defaultConstructors
from Compiler import compile
from Globals import HTMLFile, default__class_init__

class SSMethod(Provider,ProxyManager):

    """SkinScript Method"""
    
    __plugin_kind__ = "Attribute Provider"
    meta_type = "SkinScript Method"

    manage_options = (
        Provider.manage_options +
        ({'label':'Upload', 'action':'manage_uploadForm'},) +
        ProxyManager.manage_options
    )
    
    text = ''
    _providers = ()
    
    def _propertiesChanged(self):
        providers = self._providers = compile(self.text)
        
        for p in providers:
            p._proxy_roles = self._proxy_roles
            p.id = '%s, line %d' % (self.id,p.lineno); p.title = self.title
            
    def _getProviders(self):
        return self._providers

    _properties=(
        {'id':'title', 'type': 'string', 'mode': 'w'},
        {'id':'text', 'type': 'text', 'mode': 'w'},
    )

    propertyLabels = {
        'text':'Commands',
    }

    manage_uploadForm=HTMLFile('ssUpload',globals())
    
    def manage_upload(self,file='', REQUEST=None):
        """Replace the contents of the method with the text in file."""
        self._validateProxy(REQUEST)
        if type(file) is not type(''): file=file.read()
        self.manage_changeProperties(text=file)
        if REQUEST: return MessageDialog(
                    title  ='Success!',
                    message='Your changes have been saved',
                    action ='manage_main')

    def PUT(self, REQUEST, RESPONSE):
        """Handle HTTP PUT requests."""
        self.dav__init(REQUEST, RESPONSE)
        body=REQUEST.get('BODY', '')
        self._validateProxy(REQUEST)
        self.manage_changeProperties(text=body)
        RESPONSE.setStatus(204)
        return RESPONSE

    __ac_permissions__ = (
        ('View management screens', ('manage_uploadForm',)),
        ('Change SkinScript methods',
            ('manage_upload','PUT','manage_changeProperties','manage_editProperties',
             'manage_addProperty','manage_delProperties')),
    )

default__class_init__(SSMethod)

def initialize(context):
    context.registerPlugInClass(
        SSMethod,
        permission = 'Add SkinScript Methods',
        constructors = defaultConstructors(SSMethod,globals()),
        icon = 'www/trigger.gif'
    )

